#include "PDTNodeDefs.h"
const char * PDTNodeTypeStringMap[NodeType_LastOne] = {
	"Node",
	"CodeGraph",
	"Exp",
	"UnresolvedExp",
	"ExpNum",
	"ExpBool",
	"UnaryNumExp",
	"Var",
	"Const",
	"ExpNumBin",
	"ExpNumUn",
	"ExpNumSing",
	"NumVar",
	"NumConst",
	"NumConstInt",
	"NumConstDbl",
	"ExpBoolBinBool",
	"ExpBoolBinNum",
	"ExpBoolBinBoolDerived",
	"ExpBoolBinNumDerived",
	"ExpBoolUn",
	"ExpBoolSing",
	"BoolVar",
	"BoolConst",
	"<",
	">",
	"<=",
	">=",
	"==",
	"->",
	"xor",
	"==",
	"!=",
	"!=",
	"+",
	"-",
	"*",
	"/",
	"%",
	"-",
	"!",

	"Statement",
	"ite",
	"=",
	"while",
	"ListOfStatements",
	"assert",
	"Condition",
	"pre",
	"post",
	"always",
	"behavior",
	"property",
	"good",
	"bad",
    "{P}S{Q}{B}",

	"&",
	"|",
	".f(.){}",
    "f(.)",

	"{.,...}", // types
    "[ .. ]",
	"<.,...>",
	"<,...>const",
	"<.,.>",
	"{.} x {.}",

	"{.}-v",
    "<.>-v",

	"forall",// Quantifiers
	"exist",

	"U{.}",// Set expressions - union
	"I{.}",//intersect
	"^{.}", // complement

	"in", // Boolean set expressions // member
	"C=", // SubsetEq
	"|.|",// Cardinality
	".x.",// Relational or Cartesian product

	"[]", // Array access - sequence access number
	"[]", // sequence access bool
    "PDTMapConst"
};
