#include "PDTAntlrProperties.h"


unsigned int
PDTANTLRProperty::getLine(unsigned int index) {
    assert(index>=0);
    return line[index];
}

int
PDTANTLRProperty::getCharPosition(unsigned int index) {
    assert(index>=0);
    return charPosition[index];
}

long long
PDTANTLRProperty::getStart(unsigned int index){
    assert(index>=0);
    return start[index];
}

long long
PDTANTLRProperty::getStop(unsigned int index){
    assert(index>=0);
    return stop[index];
}

unsigned int
PDTANTLRProperty::setLine(unsigned int & aLine){
    line.push_back(aLine);
    return line [idx++];
}

int
PDTANTLRProperty::setCharPosition(int & aCharPosition){
    charPosition.push_back(aCharPosition);
    return charPosition [idx++];
}

long long
PDTANTLRProperty::setStart(long long & aStart){
    start.push_back(aStart);
    return start [idx++];
}

long long
PDTANTLRProperty::setStop(long long & aStop){
    stop.push_back(aStop);
    return stop [idx++];
}

void
PDTANTLRProperty::setAllData(PDTANTLRProp_t & prop){
    setLine(prop.line);
    setCharPosition(prop.charPosition);
    setStart(prop.start);
    setStop(prop.stop);
}
